---
title: MutationObserverInit.attributeFilter
slug: Web/API/MutationObserverInit/attributeFilter
tags:
  - API
  - Attribute
  - Changes
  - DOM
  - DOM WHATWG
  - Mutation Observers
  - MutationObserverInit
  - Observer
  - Property
  - atttributeFilter
  - mutation
---
<div>{{APIRef("DOM WHATWG")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("MutationObserverInit")}}</strong> dictionary's optional <strong><code>attributeFilter</code></strong> property is an array of strings specifying the names of the attributes whose values are to be monitored for changes.</span> If this property is specified, there's no need to also set {{domxref("MutationObserverInit.attributes", "attributes")}} to <code>true</code>, as it's implied.</p>

<p>If the {{domxref("MutationObserverInit.attributes", "attributes")}} permission is <code>true</code> but no <code>attributeFilter</code> is included in the options object, all attributes' values are watched for changes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>options</em> = {
  <em>attributeFilter</em>: [ <em>"list"</em>, <em>"of"</em>, <em>"attribute"</em>, <em>"names"</em> ]
}
</pre>

<h3 id="Value">Value</h3>

<p>An array of {{domxref("DOMString")}} objects, each specifying the name of one attribute whose value is to be monitored for changes. There is no default value.</p>

<p>If this property exists on the options object when the {{domxref("MutationObserver.MutationObserver", "MutationObserver()")}} constructor is used to create a new <code>MutationObserver</code>, attribute monitoring is enabled regardless of whether or not the {{domxref("MutationObserverInit.attributes", "attributes")}} property is <code>true</code>.</p>

<h2 id="Example">Example</h2>

<p>In this example, a Mutation Observer is set up to watch for changes to the <code>status</code> and <code>username</code> attributes in any elements contained within a subtree that displays the names of users in a chat room. This lets the code, for example, reflect changes to users' nicknames, or to mark them as away from keyboard (AFK) or offline.</p>

<pre class="brush: js">function callback(mutationList) {
  mutationList.forEach(function(mutation) {
    switch(mutation.type) {
      case "attributes":
        switch(mutation.attributeName) {
          case "status":
            userStatusChanged(mutation.target.username, mutation.target.status);
            break;
          case "username":
            usernameChanged(mutation.oldValue, mutation.target.username);
            break;
        }
        break;
    }
  });
}

var userListElement = document.querySelector("#userlist");

var observer = new MutationObserver(callback);
observer.observe(userListElement, {
  attributeFilter: [ "status", "username" ],
  attributeOldValue: true,
  subtree: true
});</pre>

<p>The <code>callback()</code> function—which will be passed into the {{domxref("MutationObserver.observe", "observe()")}} method when starting the observer, looks at each item in the list of {{domxref("MutationRecord")}} objects. For any items representing an attribute change (which can be detected by the value of {{domxref("MutationRecord.type")}} being <code>"attributes"</code>), we use the attribute's name, obtained using {{domxref("MutationRecord.attributeName")}}, to identify the type of change that occurred and then dispatch to the appropriate handler function.</p>

<p>Note the use of {{domxref("MutationRecord.oldValue")}} to get the previous value of the <code>"username"</code> property so we have that information when doing lookups in our local array of users.</p>

<p>When <code>observe()</code> is called, the specified options include both <code>attributeFilter</code> and {{domxref("MutationObserverInit.subtree", "subtree")}}, so that we monitor the attribute values for all of the nodes contained within the subtree rooted at the node with the ID <code>"userlist"</code>. The {{domxref("MutationObserverInit.attributeOldValue", "attributeOldValue")}} option is set to <code>true</code> because we want the prior value of the changed attributes recorded and reported in the mutation records we receive.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#dom-mutationobserverinit-attributefilter', 'MutationObserverInit: attributeFilter')}}</td>
			<td>{{ Spec2('DOM WHATWG') }}</td>
			<td> </td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MutationObserverInit.attributeFilter")}}</p>
</div>
